<?php
declare(strict_types=1);

namespace App\Controller;

use App\Form\ColorType;
use App\Model\ColorVo;
use App\Model\ParentModel;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Form\DataMapperInterface;
use Symfony\Component\Form\Exception\TransformationFailedException;
use Symfony\Component\Form\Exception\UnexpectedTypeException;
use Symfony\Component\Form\Extension\Core\Type\FormType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormFactoryInterface;
use Symfony\Component\Routing\Annotation\Route;

class TestVoFormController extends AbstractController
{
    /**
     * @Route("/test", name="test_vo_form")
     */
    public function index(FormFactoryInterface $formFactory)
    {
        $form = $formFactory->createNamedBuilder('', FormType::class, null, ['data_class' => ParentModel::class, 'empty_data' => function () { return new ParentModel('', new ColorVo('foo')); }])
            ->setDataMapper(new class implements DataMapperInterface {
                public function mapDataToForms($viewData, iterable $forms)
                {
                    if ($viewData === null) {
                        return;
                    }
                    $forms = iterator_to_array($forms);
                    $forms['color']->setData($viewData->getColor());
                    $forms['content']->setData($viewData->getContent());
                }

                public function mapFormsToData(iterable $forms, &$viewData)
                {
                    throw new TransformationFailedException('hello');
                    $forms = iterator_to_array($forms);
                    $viewData = new ParentModel($forms['content']->getData(), $forms['color']->getData());
                }
            })
            ->add('color', ColorType::class)
            ->add('content', TextType::class)
            ->getForm();
        $form->submit(['color' => '#000000', 'content' => 'foobar']);

        return $this->json([
            'message' => 'Welcome to your new controller!',
            'path' => 'src/Controller/TestVoFormController.php',
        ]);
    }
}
